import { KNativePointer } from "../../src/reexport-for-generated";
import { Es2pandaAstNodeType } from "./../Es2pandaEnums";
import { Es2pandaTSOperatorType } from "./../Es2pandaEnums";
import { TypeNode } from "./TypeNode";
export declare class TSTypeOperator extends TypeNode {
    constructor(pointer: KNativePointer, astNodeType: Es2pandaAstNodeType);
    static createTSTypeOperator(type: TypeNode | undefined, operatorType: Es2pandaTSOperatorType): TSTypeOperator;
    static updateTSTypeOperator(original: TSTypeOperator | undefined, type: TypeNode | undefined, operatorType: Es2pandaTSOperatorType): TSTypeOperator;
    get type(): TypeNode | undefined;
    get isReadonly(): boolean;
    get isKeyof(): boolean;
    get isUnique(): boolean;
    protected readonly brandTSTypeOperator: undefined;
}
export declare function isTSTypeOperator(node: object | undefined): node is TSTypeOperator;
